﻿using UnityEngine;
using System.Collections;

/* Tonasz Ludum Dare 48 */

public class RoboMove : MonoBehaviour {

	public bool isPlayer;
	float speedMove = 0.1f;
	int weaponAnim = 1;
	public int animationF = 0;
	public bool blockedOwnAnim = false;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {

		if (!isPlayer)
			transform.localScale = new Vector3(-1.5f,1.5f,1);
		else 
			transform.localScale = new Vector3(1.5f,1.5f,1);



		if (animationF == 0 && !blockedOwnAnim) {
			int directionChanger = 1;
			if (!isPlayer) directionChanger = -1;

				if (Mathf.Abs(transform.position.x) > 8f)
					MoveTo(directionChanger*-4f);
				else MoveTo(directionChanger*-10f);

		}

		//if (previousPosition == transform.position && animationF == 1)
		//	animationF = 0;
	}

	public void Attack() {
		Transform WeaponTrans = transform.FindChild("Weapon");
		if (WeaponTrans == null) WeaponTrans = transform.FindChild("Weapon(Clone)");
		if (weaponAnim == 1)
			WeaponTrans.animation.Play("a_slash0");
		if (weaponAnim == 2)
			WeaponTrans.animation.Play("a_slash1");
		if (weaponAnim == 3)
			WeaponTrans.animation.Play("a_fire");
	}

	public void MoveTo(float newX) {
		StartCoroutine(MoveToC(newX));
	}

	//float newX;
	IEnumerator MoveToC(float newX) {
		bool exit = false;
		animationF = 1;
		//newX = newX2;
		Vector3 moveVector = new Vector3(speedMove,0,0);
		if (newX < transform.position.x) moveVector *= -1f;
		while (Mathf.Abs(transform.position.x - newX)>0.1f && !exit) {
			if (!(blockedOwnAnim && Mathf.Abs(newX) != 3)) {
				transform.position += moveVector;
			}
			else exit = true;
			yield return null;
		}
		animationF = 0;
	}
}
